<template>
	<div class="container">
	  	<div class="form-row">
		    <div class="col-4">
		    	<span>Date Range</span>
		    	<date-picker
					format="DD/MM/YYYY"
					v-model="start_date"
					range
					class="input-date-custom"
				/>
		    </div>
		    <div class="col-1">
		      	<button type="button" class="btn btn-primary btn-filter" v-on:click="fnFilterDate(start_date)">Filter</button>
		    </div>
		    <div class="col-12">
		      	<vue-good-table
			      :columns="columns"
			      :rows="rows"
			      :pagination-options="{
				    enabled: true,
				    perPage: 10,
				    position: 'bottom',
				    perPageDropdown: [10, 50, 100],
				    nextLabel: 'next',
				    prevLabel: 'prev',
				    dropdownAllowAll: false
				  }"
				  :search-options="{
				    enabled: true
				  }">
				</vue-good-table>
		    </div>
		    <div class="col-12" v-if="chartData.labels.length > 0">
		      	<line-chart :data="chartData" :options="chartOptions"></line-chart>
		    </div>
	  	</div>
    </div>
</template>
<script>
	import DatePicker from 'vue2-datepicker';
  	import 'vue2-datepicker/index.css';
	export default {
		components: { DatePicker },
	    data() {
	        return {
	        	start_date: "",
	        	columns: [{
			        label: 'Date',
			        field: 'date',
			        formatFn: this.formatDate
			    }, {
			        label: 'Cases',
			        field: 'cases',
			        formatFn: this.formatNumber
			    }, {
			        label: 'Deaths',
			        field: 'deaths',
			        formatFn: this.formatNumber
			    }, {
			        label: 'Recovered',
			        field: 'recovered',
			        formatFn: this.formatNumber
			    }],
		     	rows: [],
		     	chartData: {
		     		labels: [],
		          	datasets: [{
		            	label: 'Cases',
		            	data: [],
		            	borderColor: "blue",
		          	}, {
		            	label: 'Deaths',
		            	data: [],
		            	borderColor: "red",
		          	}, {
		            	label: 'Decovered',
		            	data: [],
		            	borderColor: "green",
		          	}]
		        },
			    chartOptions: {
			      	responsive: true,
			      	maintainAspectRatio: false
			    }
		    };
	    },
	    methods: {
	    	fnFilterDate: async function (data_range) {
	    		console.log('data_range', data_range)
	    		this.chartData.labels = [];
    			let obj = await fetch(
		            'https://disease.sh/v3/covid-19/historical/all?lastdays=30'
		        ).then(res => res.json());
		        let data = this.setData(obj);
				let date_convert = [];
				let cases = [];
				let deaths = [];
				let recovered = [];
				let rows = [];

				if (data.table.length > 0) {
					for (var i = 0; i < data.table.length; i++) {
						if ((data.table[i].date.getTime() >= data_range[0].getTime()) && (data.table[i].date.getTime() <= data_range[1].getTime())) {  //มากกว่่าหรือเท่ากับ start และ น้อยกว่าหรือเท่ากับ end
							rows.push(data.table[i]);
							date_convert.push(this.$moment(new Date(data.table[i].date)).format("DD/MM/YYYY"));
							cases.push(data.table[i].cases);
							deaths.push(data.table[i].deaths);
							recovered.push(data.table[i].recovered);
						}
					}
				}

				this.rows = rows;
				this.chartData.labels = date_convert;
		        this.chartData.datasets[0].data = cases;
		        this.chartData.datasets[1].data = deaths;
		        this.chartData.datasets[2].data = recovered;
		    },
		  	formatNumber: function(value) {
				return Number(value).toLocaleString();
			},
			formatDate: function(value) {
				return this.$moment(new Date(value)).format("DD/MM/YYYY");
			},
			setData: function(value) {
				// console.log('value', value)
				let date = Object.keys(value.cases);
				let value_cases = Object.values(value.cases);
				let value_deaths = Object.values(value.deaths);
				let value_recovered = Object.values(value.recovered);
				// console.log(date, value_cases, value_deaths, value_recovered)
				let data = [];
				let date_convert = [];
				for (var i = 0; i < 30; i++) {
					let obj = {
						"date": new Date(date[i]),
						"cases": value_cases[i],
						"deaths": value_deaths[i],
						"recovered": value_recovered[i]
					}
					data.push(obj);
					date_convert.push(this.$moment(new Date(obj.date)).format("DD/MM/YYYY"));
				}
				let data_all = {
					"table": data,
					"chart": {
						"labels": date_convert,
						"cases": value_cases,
						"deaths": value_deaths,
						"recovered": value_recovered
					}
				}
				// console.log(data_all)
				return data_all;
			}
		},
	    async fetch() {
	        let obj = await fetch(
	            'https://disease.sh/v3/covid-19/historical/all?lastdays=30'
	            // "https://disease.sh/v3/covid-19/jhucsse"
	        ).then(res => res.json())
	        let data = this.setData(obj);
	        // console.log(data)
	        this.rows = data.table;
	        this.chartData.labels = data.chart.labels;
	        this.chartData.datasets[0].data = data.chart.cases;
	        this.chartData.datasets[1].data = data.chart.deaths;
	        this.chartData.datasets[2].data = data.chart.recovered;
	        console.log(this.chartData)
	    }
	};
</script>

<style>
	.input-date-custom {
		width: 100%;
	}

	.btn-filter {
		position: absolute;
	    top: 36px;
	    width: 100%;
	    height: 34px;
	    font-size: 14px;
	}

	.fix-lable {
		display: flex;
	}
</style>